## mknbi 1.2.7

=== Makefile ===
VERSION=1.2-7
TARVERSION=1.2
# spec file can override
RPMVERSION=$(VERSION)

# If you don't have either nasm or the ELKS as86, then just do make
# and make install because the assembler sources are supplied preassembled
# If you do make realclean you will have to unpack the mknbi archive again

# Use nasm or as86
ASM=nasm
# This must be the as86 from the ELKS project, the default Linux one won't do
#ASM=as86

# for first32*.linux
# This one makes multiple versions
FIRSTRELOCS=	0x92800 0x82800
OLDGAS:=	$(shell $(AS) --version | grep -q '2\.9\.1' && echo -DGAS291)
CFLAGS=		-Os -ffreestanding -fstrength-reduce -fomit-frame-pointer \
		-mcpu=i386 \
		-Wall -W -Wno-format -Wno-unused -DVERSION=\"$(VERSION)\"
LDBINARYFLAG=	--oformat binary

# for FreeDOS
FDKSEG=	0x60

# for menu
MENURELOC=	0x10000

PREFIX=		/usr/local
INSTPREFIX=	$(BUILD_ROOT)$(PREFIX)
LIBDIR=		$(PREFIX)/lib/mknbi
INSTLIBDIR=	$(INSTPREFIX)/lib/mknbi
BINDIR=		$(INSTPREFIX)/bin
MANDIR=		$(INSTPREFIX)/man/man1
DOCDIR=		$(INSTPREFIX)/doc/mknbi-$(RPMVERSION)

INSTALL=	install

PROG=	mknbi disnbi dismbr disdosbb
MODULES=Nbi.pm Elf.pm TruncFD.pm
FIRSTS=	first16.linux \
	$(foreach i,$(FIRSTRELOCS),first32@$(i).linux first32pm@$(i).linux first32elf@$(i).linux) \
	first.dos first.fdos menu
ALTBOOT=altboot.bin
RMRD=	rmrd.com
MANS=	mknbi.1 disnbi.1 menuc.1
HTMLS=	mknbi.html disnbi.html menuc.html
DOCS=	$(MANS) $(HTMLS)


all:	$(PROG) $(FIRSTS) $(RMRD) $(DOCS)

# Tagged image builder
mknbi:	mknbi.pl Nbi.pm TruncFD.pm
	sed -e 's:@@VERSION@@:$(VERSION):' -e 's:@@LIBDIR@@:$(LIBDIR):' -e 's/@@FDKSEG@@/$(FDKSEG)/' mknbi.pl > $@
	chmod 755 $@

# Tagged image display and disassemble
disnbi:	disnbi.pl
	cp -p disnbi.pl disnbi
	chmod 755 disnbi

# Master boot record display
dismbr:	dismbr.pl
	cp -p dismbr.pl dismbr
	chmod 755 dismbr

# DOS boot block display
disdosbb:	disdosbb.pl
	cp -p disdosbb.pl disdosbb
	chmod 755 disdosbb

# Old 16-bit first stage setup program
first16.linux:	first-linux.S first-linux.h version-linux.h
ifeq ($(ASM),as86)
	gcc $(ASMCFLAGS) -DUSE_AS86 -E -traditional -o first-linux.s first-linux.S
	as86 -0 -b first16.linux first-linux.s
else
	gcc $(ASMCFLAGS) -DUSE_NASM -E -traditional -o first-linux.s first-linux.S
	nasm -f bin first-linux.s -o first16.linux
endif

# New 32-bit first stage setup program
first32@%.linux:	start32@%.o first32.o memsizes.o printf.o
	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32.o memsizes.o printf.o
	@if [ `wc -c < $@` -gt 6144 ]; then echo Binary too large; fi

# New 32-bit first stage protected mode call setup program
first32pm@%.linux:	start32pm@%.o first32pm.o memsizes.o printf.o
	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32pm@$*.o first32pm.o memsizes.o printf.o
	@if [ `wc -c < $@` -gt 6144 ]; then echo Binary too large; fi

# New 32-bit first stage ELF setup program
first32elf@%.linux:	start32pm@%.o first32elf.o memsizes.o printf.o
	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32pm@$*.o first32elf.o memsizes.o printf.o
	@if [ `wc -c < $@` -gt 6144 ]; then echo Binary too large; fi

start32@%.o:	start32.S
	gcc -E -DRELOC=$* $(OLDGAS) start32.S | $(AS) -o start32@$*.o

start32pm@%.o:	start32.S
	gcc -E -DFIRST32PM -DRELOC=$* $(OLDGAS) start32.S | $(AS) -o start32pm@$*.o

first32.o:	first32.c etherboot.h
	gcc $(CFLAGS) -c $*.c

first32pm.o:	first32.c etherboot.h
	gcc $(CFLAGS) -DFIRST32PM -o first32pm.o -c first32.c

first32elf.o:	first32.c etherboot.h
	gcc $(CFLAGS) -DFIRST32ELF -o first32elf.o -c first32.c

memsizes.o:		memsizes.c
	gcc $(CFLAGS) -c $*.c

printf.o:		printf.c
	gcc $(CFLAGS) -c $*.c

# DOS first stage setup program, depend on Makefile for version number
first.dos:	first-dos.S first-dos.h version-dos.h Makefile
ifeq ($(ASM),as86)
	gcc $(ASMCFLAGS) -DUSE_AS86 -DVENDOR_MAGIC=\"mknbi-dos-$(VERSION)\" -E -traditional -o first-dos.s first-dos.S
	as86 -0 -b first.dos first-dos.s
else
	gcc $(ASMCFLAGS) -DUSE_NASM -DVENDOR_MAGIC=\"mknbi-dos-$(VERSION)\" -E -traditional -o first-dos.s first-dos.S
	nasm -f bin first-dos.s -o first.dos
endif

# FreeDOS first stage setup program, depend on Makefile for version number
first.fdos:	first-dos.S first-dos.h version-dos.h Makefile
ifeq ($(ASM),as86)
	gcc $(ASMCFLAGS) -DFREEDOS -DFDKSEG=$(FDKSEG) -DUSE_AS86 -DVENDOR_MAGIC=\"mknbi-fdos-$(VERSION)\" -E -traditional -o first-fdos.s first-dos.S
	as86 -0 -b first.fdos first-fdos.s
else
	gcc $(ASMCFLAGS) -DFREEDOS -DFDKSEG=$(FDKSEG) -DUSE_NASM -DVENDOR_MAGIC=\"mknbi-fdos-$(VERSION)\" -E -traditional -o first-fdos.s first-dos.S
	nasm -f bin first-fdos.s -o first.fdos
endif

# Menu first stage program
menu:	startmenu.o menu.o string.o printf.o ansiesc.o
	$(LD) -N -Ttext $(MENURELOC) -e _start $(LDBINARYFLAG) -o $@ startmenu.o menu.o string.o printf.o ansiesc.o

# Another menu program, this one simpler
menu-simple:	startmenu.o menu-simple.o string.o printf.o ansiesc.o
	$(LD) -N -Ttext $(MENURELOC) -e _start $(LDBINARYFLAG) -o $@ startmenu.o menu-simple.o string.o printf.o ansiesc.o

startmenu.o:	startmenu.S
	gcc -E -DRELOC=$(MENURELOC) $(OLDGAS) startmenu.S | $(AS) -o startmenu.o

menu.o:		menu.c string.h etherboot.h
	gcc $(CFLAGS) -c $*.c

menu-simple.o:	menu-simple.c string.h etherboot.h
	gcc $(CFLAGS) -c $*.c

string.o:	string.h string.c
	gcc $(CFLAGS) -c $*.c

ansiesc.o:	ansiesc.c etherboot.h
	gcc $(CFLAGS) -DGFX -c $*.c

# Remove ramdisk utility under DOS
rmrd.com:	rmrd.S
ifeq ($(ASM),as86)
	gcc $(ASMCFLAGS) -DUSE_AS86 -E -traditional -o rmrd.s rmrd.S
	# -s appears to be necessary to start binary at 0x100
	as86 -0 -b rmrd.com -s rmrd.map rmrd.s
else
	gcc $(ASMCFLAGS) -DUSE_NASM -E -traditional -o rmrd.s rmrd.S
	nasm -f bin rmrd.s -o rmrd.com
endif

# Alternate boot block, taken from netboot mknbi-dos
# Not made by default because not everybody has as86 installed
$(ALTBOOT):	altboot.S
	gcc -E altboot.S > altboot.s
	as86 -s /dev/null -b $(ALTBOOT) altboot.s
	$(RM) altboot.s

$(MANS):	mknbi.pl disnbi.pl Makefile
	pod2man --date=`date +%Y-%m-%d` --release="Mknbi $(VERSION)" --center="Etherboot tools" mknbi.pl > mknbi.1
	pod2man --date=`date +%Y-%m-%d` --release="Mknbi $(VERSION)" --center="Etherboot tools" disnbi.pl > disnbi.1
	pod2man --date=`date +%Y-%m-%d` --release="Mknbi $(VERSION)" --center="Etherboot tools" menuc.pl > menuc.1

$(HTMLS):	mknbi.pl disnbi.pl
	pod2html mknbi.pl > mknbi.html
	pod2html disnbi.pl > disnbi.html
	pod2html menuc.pl > menuc.html

install:	all
	-mkdir -p $(INSTLIBDIR)
	$(INSTALL) $(PROG) $(INSTLIBDIR)/
	$(INSTALL) -m 644 $(MODULES) $(FIRSTS) $(ALTBOOT) $(RMRD) $(INSTLIBDIR)/
	-mkdir -p $(BINDIR)
	cd $(BINDIR); \
	for i in linux rom fdos dos menu; \
	do \
		ln -sf ../lib/mknbi/mknbi mknbi-$$i; \
	done; \
	for i in linux menu; \
	do \
		ln -sf ../lib/mknbi/mknbi mkelf-$$i; \
	done
	(cd $(BINDIR); ln -sf ../lib/mknbi/disnbi disnbi)
	(cd $(BINDIR); ln -sf ../lib/mknbi/dismbr dismbr)
	(cd $(BINDIR); ln -sf ../lib/mknbi/disdosbb disdosbb)
	-mkdir -p $(MANDIR)
	$(INSTALL) -m 644 mknbi.1 disnbi.1 $(MANDIR)/
	-mkdir -p $(DOCDIR)
	$(INSTALL) -m 644 README LOG RELNOTES spec.txt $(DOCDIR)/

tarball:
	(cd ..; tar zcf /tmp/mknbi-$(TARVERSION).tar.gz --exclude CVS mknbi-$(TARVERSION))

clean:
	$(RM) -f $(PROG) start32*.o start32pm*.o first32*.o first32pm*.o \
	first32elf*.o printf.o menu.o menu-simple.o startmenu.o string.o ansiesc.o \
	first-linux.s first-dos.s first-fdos.s rmrd.s rmrd.map *.l pod2htm*

realclean:	clean
	$(RM) -f $(FIRSTS) $(RMRD) $(DOCS)

## mknbi 1.4.3

=== Makefile ===
VERSION=1.4.3
EXTRAVERSION=
TARVERSION=1.4.3
# spec file can override
RPMVERSION=$(VERSION)

# If you don't have either nasm or the ELKS as86, then just do make
# and make install because the assembler sources are supplied preassembled
# If you do make realclean you will have to unpack the mknbi archive again

# Use nasm or as86
ASM=nasm
# This must be the as86 from the ELKS project, the default Linux one won't do
#ASM=as86

# for first32*.linux
# This one makes multiple versions
FIRSTRELOCS=	0x92800 0x82800
OLDGAS:=	$(shell $(AS) --version | grep -q '2\.9\.1' && echo -DGAS291)
CFLAGS=		-I. -Os -ffreestanding -fstrength-reduce -fomit-frame-pointer \
		-mcpu=i386 \
		-Wall -W -Wno-format -Wno-unused -DVERSION=\"$(VERSION)$(EXTRAVERSION)\"
LDBINARYFLAG=	--oformat binary
FIRST32SIZE=	6144

# for first32dos
F32DRELOC=0x93000

# for FreeDOS
FDKSEG=	0x60

# for menu
MENURELOC=	0x60000
# Options for auxiliary menu program
# Available: -DANSIESC -DMOTD -DUSRPARMS -DPASSWD
# -DCONSOLE_CRT -DCONSOLE_SERIAL -DSHOW_NUMERIC -DPOWERSAVE
# Might as well take the lot since code size is not a concern
# Must pick ANSIMODE=1 if ANSIESC is chosen
BOOTMENU_FLAGS=	-DCONSOLE_CRT -DANSIESC -DANSIMODE=1 -DMOTD -DUSRPARMS -DPASSWD -DPOWERSAVE -DCOMCONSOLE=0x3f8 -DCOMPRESERVE

PREFIX=		/usr/local
INSTPREFIX=	$(BUILD_ROOT)$(PREFIX)
LIBDIR=		$(PREFIX)/lib/mknbi
INSTLIBDIR=	$(INSTPREFIX)/lib/mknbi
BINDIR=		$(INSTPREFIX)/bin
MANDIR=		$(INSTPREFIX)/share/man/man1
DOCDIR=		$(INSTPREFIX)/share/doc/mknbi-$(RPMVERSION)

INSTALL=	install

PROG=	mknbi disnbi dismbr disdosbb nbitoelf
MODULES=Nbi.pm Elf.pm TruncFD.pm
FIRSTS=	$(foreach i,$(FIRSTRELOCS),first32@$(i).linux first32elf@$(i).linux) \
	first.dos first.fdos menu nfl
ALTBOOT=altboot.bin
RMRD=	rmrd.com
MANS=	mknbi.1 disnbi.1 menuc.1
HTMLS=	mknbi.html disnbi.html menuc.html
DOCS=	$(MANS) $(HTMLS)


all:	$(PROG) $(FIRSTS) $(RMRD) $(DOCS)

# Tagged image builder
mknbi:	mknbi.pl Nbi.pm TruncFD.pm
	perl -ne 's|\@\@VERSION\@\@|$(VERSION)|; s|\@\@LIBDIR\@\@|$(LIBDIR)|; s|\@\@FDKSEG\@\@|$(FDKSEG)|; print $$_;' mknbi.pl > $@
	chmod 755 $@

# Tagged image display and disassemble
disnbi:	disnbi.pl
	cp -p disnbi.pl disnbi
	chmod 755 disnbi

# Master boot record display
dismbr:	dismbr.pl
	cp -p dismbr.pl dismbr
	chmod 755 dismbr

# DOS boot block display
disdosbb:	disdosbb.pl
	cp -p disdosbb.pl disdosbb
	chmod 755 disdosbb

# NBI to ELF converter
nbitoelf:	nbitoelf.pl
	cp -p nbitoelf.pl nbitoelf
	chmod 755 nbitoelf

# 32-bit first stage protected mode call setup program
first32@%.linux:	start32@%.o first32.o memsizes.o printf.o
	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32.o memsizes.o printf.o
	@if [ `wc -c < $@` -gt $(FIRST32SIZE) ]; then echo Binary too large; fi

# 32-bit first stage ELF setup program
first32elf@%.linux:	start32@%.o first32elf.o memsizes.o printf.o
	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32elf.o memsizes.o printf.o
	@if [ `wc -c < $@` -gt $(FIRST32SIZE) ]; then echo Binary too large; fi

# 32-bit first stage ELF DOS setup program
first32elf@%.dos:	start32@%.o first32dos.o printf.o
	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32dos.o printf.o

start32@%.o:	start32.S
	gcc -E -DRELOC=$* $(OLDGAS) start32.S | $(AS) -o start32@$*.o

first32.o:	first32.c etherboot.h start32.h
	gcc $(CFLAGS) -o first32.o -c first32.c

first32elf.o:	first32.c etherboot.h start32.h
	gcc $(CFLAGS) -DFIRST32ELF -o first32elf.o -c first32.c

first32dos.o:	first32.c etherboot.h start32.h
	gcc $(CFLAGS) -DRELOC=$(F32DRELOC) -DFIRST32DOS -DFIRST32ELF -o first32dos.o -c first32.c

memsizes.o:		memsizes.c
	gcc $(CFLAGS) -c $*.c

printf.o:		printf.c
	gcc $(CFLAGS) -c $*.c

# DOS first stage setup program, depend on Makefile for version number
first.dos:	first-dos.S first-dos.h version-dos.h Makefile
ifeq ($(ASM),as86)
	gcc $(ASMCFLAGS) -DUSE_AS86 -DVENDOR_MAGIC=\"mknbi-dos-$(VERSION)\" -E -traditional -o first-dos.s first-dos.S
	as86 -0 -b first.dos first-dos.s
else
	gcc $(ASMCFLAGS) -DUSE_NASM -DVENDOR_MAGIC=\"mknbi-dos-$(VERSION)\" -E -traditional -o first-dos.s first-dos.S
	nasm -f bin first-dos.s -o first.dos
endif

# FreeDOS first stage setup program, depend on Makefile for version number
first.fdos:	first-dos.S first-dos.h version-dos.h Makefile
ifeq ($(ASM),as86)
	gcc $(ASMCFLAGS) -DFREEDOS -DFDKSEG=$(FDKSEG) -DUSE_AS86 -DVENDOR_MAGIC=\"mknbi-fdos-$(VERSION)\" -E -traditional -o first-fdos.s first-dos.S
	as86 -0 -b first.fdos first-fdos.s
else
	gcc $(ASMCFLAGS) -DFREEDOS -DFDKSEG=$(FDKSEG) -DUSE_NASM -DVENDOR_MAGIC=\"mknbi-fdos-$(VERSION)\" -E -traditional -o first-fdos.s first-dos.S
	nasm -f bin first-fdos.s -o first.fdos
endif

first-elf.dos:	first.dos first32elf@$(F32DRELOC).dos
	cat first.dos first32elf@$(F32DRELOC).dos > first-elf.dos

first-elf.fdos:	first.fdos first32elf@$(F32DRELOC).dos
	cat first.fdos first32elf@$(F32DRELOC).dos > first-elf.fdos

# Menu first stage program
menu:	startmenu.o menu.o bootmenu.o string.o printf.o ansiesc.o md5.o misc.o serial.o
	$(LD) -N -Ttext $(MENURELOC) -e _start $(LDBINARYFLAG) -o $@ startmenu.o menu.o bootmenu.o string.o printf.o ansiesc.o md5.o misc.o serial.o

# Another menu program, this one simpler
menu-simple:	startmenu.o menu-simple.o string.o printf.o ansiesc.o
	$(LD) -N -Ttext $(MENURELOC) -e _start $(LDBINARYFLAG) -o $@ startmenu.o menu-simple.o string.o printf.o ansiesc.o

# Network FreeLoader (light-bar menu program)
nfl:	startmenu.o nfl.o string.o printf.o ansiesc.o
	$(LD) -N -Ttext $(MENURELOC) -e _start $(LDBINARYFLAG) -o $@ startmenu.o nfl.o string.o printf.o ansiesc.o

# LUA interpreter
lua/bin/lua:
	cd lua; make

startmenu.o:	startmenu.S startmenu.h
	gcc -E -Ui386 -DRELOC=$(MENURELOC) $(OLDGAS) startmenu.S | $(AS) -o startmenu.o

menu.o:		menu.c stddef.h string.h printf.h ansiesc.h \
		misc.h linux-asm-io.h etherboot.h
	gcc $(CFLAGS) $(BOOTMENU_FLAGS) -c $*.c

bootmenu.o:	bootmenu.h bootmenu.c stddef.h string.h md5.h misc.h etherboot.h start32.h
	gcc $(CFLAGS) $(BOOTMENU_FLAGS) -c $*.c

string.o:	string.h string.c
	gcc $(CFLAGS) -c $*.c

ansiesc.o:	ansiesc.h ansiesc.c stddef.h string.h etherboot.h
	gcc $(CFLAGS) -DGFX -c $*.c

md5.o:	md5.h md5.c etherboot.h
	gcc $(CFLAGS) $(BOOTMENU_FLAGS) -c $*.c

misc.o:	misc.h misc.c ansiesc.h etherboot.h start32.h
	gcc $(CFLAGS) $(BOOTMENU_FLAGS) -c $*.c

serial.o:	serial.c
	gcc $(CFLAGS) $(BOOTMENU_FLAGS) -c $*.c

menu-simple.o:	menu-simple.h menu-simple.c string.h etherboot.h
	gcc $(CFLAGS) -c $*.c

# Remove ramdisk utility under DOS
rmrd.com:	rmrd.S
ifeq ($(ASM),as86)
	gcc $(ASMCFLAGS) -DUSE_AS86 -E -traditional -o rmrd.s rmrd.S
	# -s appears to be necessary to start binary at 0x100
	as86 -0 -b rmrd.com -s rmrd.map rmrd.s
else
	gcc $(ASMCFLAGS) -DUSE_NASM -E -traditional -o rmrd.s rmrd.S
	nasm -f bin rmrd.s -o rmrd.com
endif

# Alternate boot block, taken from netboot mknbi-dos
# Not made by default because not everybody has as86 installed
$(ALTBOOT):	altboot.S
	gcc -E altboot.S > altboot.s
	as86 -s /dev/null -b $(ALTBOOT) altboot.s
	$(RM) altboot.s

$(MANS):	mknbi.pl disnbi.pl Makefile
	pod2man --date=`date +%Y-%m-%d` --release="Mknbi $(VERSION)$(EXTRAVERSION)" --center="Etherboot tools" mknbi.pl > mknbi.1
	pod2man --date=`date +%Y-%m-%d` --release="Mknbi $(VERSION)$(EXTRAVERSION)" --center="Etherboot tools" disnbi.pl > disnbi.1
	pod2man --date=`date +%Y-%m-%d` --release="Mknbi $(VERSION)$(EXTRAVERSION)" --center="Etherboot tools" menuc.pl > menuc.1

$(HTMLS):	mknbi.pl disnbi.pl
	pod2html mknbi.pl > mknbi.html
	pod2html disnbi.pl > disnbi.html
	pod2html menuc.pl > menuc.html

install:	all $(ALTBOOT)
	-mkdir -p $(INSTLIBDIR)
	$(INSTALL) $(PROG) $(INSTLIBDIR)/
	$(INSTALL) -m 644 $(MODULES) $(FIRSTS) $(ALTBOOT) $(RMRD) $(INSTLIBDIR)/
	if [ -e lua-4.0.1/bin/lua ]; then \
		cp -p lua-4.0.1/bin/lua lua; \
	fi
	if [ -e lua ]; then \
		$(INSTALL) -m 644 lua $(INSTLIBDIR)/lua; \
	fi
	-mkdir -p $(BINDIR)
	cd $(BINDIR); \
	for i in linux rom fdos dos menu nfl; \
	do \
		ln -sf ../lib/mknbi/mknbi mknbi-$$i; \
	done; \
	for i in linux img menu nfl lua; \
	do \
		ln -sf ../lib/mknbi/mknbi mkelf-$$i; \
	done
	(cd $(BINDIR); ln -sf ../lib/mknbi/disnbi disnbi)
	(cd $(BINDIR); ln -sf ../lib/mknbi/dismbr dismbr)
	(cd $(BINDIR); ln -sf ../lib/mknbi/disdosbb disdosbb)
	(cd $(BINDIR); ln -sf ../lib/mknbi/nbitoelf nbitoelf)
	-mkdir -p $(MANDIR)
	$(INSTALL) -m 644 mknbi.1 disnbi.1 $(MANDIR)/
	cd $(MANDIR); \
	for i in mkelf mknbi-linux mkelf-linux mknbi-rom mkelf-img mknbi-menu mkelf-menu mknbi-nfl mkelf-nfl mkelf-lua mknbi-dos mknbi-fdos; \
	do \
		ln -sf mknbi.1 $$i.1; \
	done
	-mkdir -p $(DOCDIR)
	$(INSTALL) -m 644 README LOG spec.txt $(DOCDIR)/

tarball:
	mkdir -p luabuild
	-diff -ur --exclude='*.a' --exclude='*.o' --exclude='*.map' --unidirectional-new-file /usr/local/src/lua-4.0.1 lua-4.0.1 > luabuild/luapatch.txt
	(cd ..; tar zcf /tmp/mknbi-$(TARVERSION).tar.gz --exclude CVS --exclude lua-4.0.1 mknbi-$(TARVERSION))

clean:
	$(RM) -f $(PROG) start32*.o first32*.o \
	printf.o menu.o menu-simple.o nfl.o startmenu.o \
	bootmenu.o md5.o misc.o serial.o ansiesc.o string.o memsizes.o \
	first-dos.s first-fdos.s rmrd.s rmrd.map *.l pod2htm*

realclean:	clean
	$(RM) -f $(FIRSTS) $(RMRD) $(DOCS)

## mknbi 1.4.4

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
-VERSION=1.4.3
+VERSION=1.4.4
 EXTRAVERSION=
-TARVERSION=1.4.3
+TARVERSION=1.4.4
 # spec file can override
 RPMVERSION=$(VERSION)
 
@@ -44,7 +44,7 @@
 INSTLIBDIR=	$(INSTPREFIX)/lib/mknbi
 BINDIR=		$(INSTPREFIX)/bin
 MANDIR=		$(INSTPREFIX)/share/man/man1
-DOCDIR=		$(INSTPREFIX)/share/doc/mknbi-$(RPMVERSION)
+DOCDIR=		$(INSTPREFIX)/share/doc/packages/mknbi-$(RPMVERSION)
 
 INSTALL=	install
 
@@ -87,18 +87,18 @@
 	chmod 755 nbitoelf
 
 # 32-bit first stage protected mode call setup program
-first32@%.linux:	start32@%.o first32.o memsizes.o printf.o
-	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32.o memsizes.o printf.o
+first32@%.linux:	start32@%.o first32.o memsizes.o printf.o string.o
+	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32.o memsizes.o printf.o string.o
 	@if [ `wc -c < $@` -gt $(FIRST32SIZE) ]; then echo Binary too large; fi
 
 # 32-bit first stage ELF setup program
-first32elf@%.linux:	start32@%.o first32elf.o memsizes.o printf.o
-	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32elf.o memsizes.o printf.o
+first32elf@%.linux:	start32@%.o first32elf.o memsizes.o printf.o string.o
+	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32elf.o memsizes.o printf.o string.o
 	@if [ `wc -c < $@` -gt $(FIRST32SIZE) ]; then echo Binary too large; fi
 
 # 32-bit first stage ELF DOS setup program
-first32elf@%.dos:	start32@%.o first32dos.o printf.o
-	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32dos.o printf.o
+first32elf@%.dos:	start32@%.o first32dos.o printf.o string.o
+	$(LD) -N -Ttext $* -e _start $(LDBINARYFLAG) -o $@ start32@$*.o first32dos.o printf.o string.o
 
 start32@%.o:	start32.S
 	gcc -E -DRELOC=$* $(OLDGAS) start32.S | $(AS) -o start32@$*.o
@@ -243,12 +243,12 @@
 	-mkdir -p $(MANDIR)
 	$(INSTALL) -m 644 mknbi.1 disnbi.1 $(MANDIR)/
 	cd $(MANDIR); \
-	for i in mkelf mknbi-linux mkelf-linux mknbi-rom mkelf-img mknbi-menu mkelf-menu mknbi-nfl mkelf-nfl mkelf-lua mknbi-dos mknbi-fdos; \
+	for i in mkelf mknbi-linux mkelf-linux mknbi-rom mkelf-img mknbi-menu mkelf-menu mknbi-nfl mkelf-nfl mknbi-dos mknbi-fdos mkelf-lua; \
 	do \
 		ln -sf mknbi.1 $$i.1; \
 	done
 	-mkdir -p $(DOCDIR)
-	$(INSTALL) -m 644 README LOG spec.txt $(DOCDIR)/
+	$(INSTALL) -m 644 COPYING README LOG spec.txt $(DOCDIR)/
 
 tarball:
 	mkdir -p luabuild

=== debian/changelog ===
mknbi (1.4.4-14) unstable; urgency=medium

  * QA upload.
  * Clean up leftover diversions dating back to lenny.  (Closes: #861259)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 26 Apr 2017 18:18:17 +0200

mknbi (1.4.4-13) unstable; urgency=medium

  * QA upload.
  * Add patch from Steve Beattie to fix PIE FTBFS. (Closes: #852851)

 -- Adrian Bunk <bunk@debian.org>  Sat, 28 Jan 2017 00:23:07 +0200

mknbi (1.4.4-12) unstable; urgency=medium

  * QA upload.
  * debian/control: added Vcs-Browser, Vcs-Git.
  * fix a misspelled override_dh_installchangelogs in debian/rules. Thanks
    to  Chris Lamb for the patch (closes: #831776).
  * patch 06-reproducible-builds.patch: make the build reproducible. Thanks
    to Chris Lamb for the patch (closes: #831432).
  * normalise name of 05-gcc-5.patch

 -- Ralf Treinen <treinen@debian.org>  Wed, 03 Aug 2016 14:40:44 +0200

mknbi (1.4.4-11) unstable; urgency=medium

  * QA upload.
  * Fix "ftbfs with GCC-5": add patch from Matthias Klose/Ubuntu:
    Build with -fgnu89-inline for GCC 5.
    (Closes: #778009)

 -- gregor herrmann <gregoa@debian.org>  Sat, 18 Jul 2015 20:55:44 +0200

mknbi (1.4.4-10) unstable; urgency=low

  * QA upload.
  * Makefile: Add -fno-stack-protector to CFLAGS (thanks, Michael Bienia;
    LP: #520648).

 -- Colin Watson <cjwatson@debian.org>  Tue, 07 May 2013 17:53:26 +0100

mknbi (1.4.4-9) unstable; urgency=low

  * Updating to debhelper version 8.
  * Updating to standards version 3.9.2.
  * Switching to source format 3.0 (quilt).
  * Compacting copyright file.
  * Orphaning package.

 -- Daniel Baumann <daniel@debian.org>  Thu, 08 Sep 2011 07:23:39 +0000

mknbi (1.4.4-8) experimental; urgency=low

  * Updating build-depends and architecture for kbfreebsd, thanks to
    Petr Salinger <Petr.Salinger@seznam.cz> (Closes: #597049).

 -- Daniel Baumann <daniel@debian.org>  Thu, 16 Sep 2010 09:47:35 +0200

mknbi (1.4.4-7) unstable; urgency=low

  * Adding patch from Colin Watson <cjwatson@ubuntu.com> to pass
    appropriate options to ld and as to make multilib build work
    (Closes: #593609).
  * Updating standards version to 3.9.1.

 -- Daniel Baumann <daniel@debian.org>  Wed, 01 Sep 2010 10:19:19 +0200

mknbi (1.4.4-6) unstable; urgency=low

  * Updating standards version to 3.9.0.
  * Building with gcc-multilib (Closes: #587734).

 -- Daniel Baumann <daniel@debian.org>  Thu, 01 Jul 2010 14:53:45 +0200

mknbi (1.4.4-5) unstable; urgency=low

  * Correcting yet another spelling error in package long-description
    (Closes: #584708).

 -- Daniel Baumann <daniel@debian.org>  Sun, 06 Jun 2010 09:35:07 +0200

mknbi (1.4.4-4) unstable; urgency=low

  * Correcting another spelling error in package long-description
    (Closes: #584618).

 -- Daniel Baumann <daniel@debian.org>  Sat, 05 Jun 2010 08:32:16 +0200

mknbi (1.4.4-3) unstable; urgency=low

  * Updating year in copyright file.
  * Updating to standards 3.8.4.
  * Correcting spelling error in package long-description (Closes:
    #584131).

 -- Daniel Baumann <daniel@debian.org>  Fri, 04 Jun 2010 17:30:33 +0200

mknbi (1.4.4-2) unstable; urgency=low

  * New maintainer, taking over package from Gergely with thanks for all his
    past work on it.
  * Redone debian packaging from scratch, including:
    - adding amd64 into architecture list (Closes: #427478).
    - adding kfreebsd-amd64 and kfreebsd-i386 into architecture list
      (Closes: #366409).

 -- Daniel Baumann <daniel@debian.org>  Wed, 16 Dec 2009 13:51:06 +0100

mknbi (1.4.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix bashism in debian/rules (Closes: #478407)
  * debian/control:
    - Bump Standards-Version to 3.8.0.
    - Move upstream URL to Homepage: field

 -- Chris Lamb <chris@chris-lamb.co.uk>  Sat, 07 Jun 2008 22:38:23 +0100

mknbi (1.4.4-1) unstable; urgency=low

  * New upstream release (closes: #323733, #329453)
  * Improvements from Erik Schanze (closes: #329452)

 -- RISKO Gergely <risko@debian.org>  Thu, 17 Nov 2005 20:41:04 +0100

mknbi (1.4.3-2) unstable; urgency=low

  * fix version string bugs (probably forever with help of Mark Williams
    (closes: #255139)
  * better copyright file written and included

 -- RISKO Gergely <risko@debian.org>  Fri, 13 Aug 2004 16:24:20 +0200

mknbi (1.4.3-1) unstable; urgency=low

  * New upstream release

 -- RISKO Gergely <risko@debian.org>  Thu, 20 May 2004 17:11:26 +0200

mknbi (1.4.0-1) unstable; urgency=low

  * New upstream release (closes: #201304)

 -- RISKO Gergely <risko@debian.org>  Tue, 15 Jul 2003 11:33:47 +0200

mknbi (1.2.12-2) unstable; urgency=low

  * fix version in debian/rules

 -- RISKO Gergely <risko@debian.org>  Wed, 26 Mar 2003 22:37:36 +0100

mknbi (1.2.12-1) unstable; urgency=low

  * New upstream release (closes: #171764)

 -- RISKO Gergely <risko@debian.org>  Fri, 17 Jan 2003 15:42:52 +0100

mknbi (1.2.7-2) unstable; urgency=low

  * fix version string in dosnbi (closes: Bug#144498)

 -- RISKO Gergely <risko@debian.org>  Sun,  5 May 2002 16:25:03 +0200

mknbi (1.2.7-1) unstable; urgency=low

  * new upstream (closes: Bug#140284)

 -- RISKO Gergely <risko@debian.org>  Thu, 28 Mar 2002 14:05:26 +0100

mknbi (1.2-4) unstable; urgency=low

  * changed the totally bad description. (closes: Bug#133983)

 -- RISKO Gergely <risko@debian.org>  Fri, 15 Feb 2002 18:45:01 +0100

mknbi (1.2-3) unstable; urgency=high

  * fixed a very nasty bug (files missing from /usr/lib/mknbi)

 -- RISKO Gergely <risko@debian.org>  Thu, 27 Dec 2001 10:47:57 +0100

mknbi (1.2-2) unstable; urgency=low

  * divert the old netboot files (closes: Bug#122403)

 -- RISKO Gergely <risko@debian.org>  Sun, 16 Dec 2001 14:31:22 +0100

mknbi (1.2-1) unstable; urgency=low

  * Initial Release. (closes: Bug#119553)

 -- RISKO Gergely <risko@debian.org>  Wed, 14 Nov 2001 19:02:41 +0100

=== debian/control ===
Source: mknbi
Section: admin
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 8), gcc-multilib [any-amd64], nasm, perl
Standards-Version: 3.9.2
Homepage: http://www.etherboot.org/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/mknbi.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/mknbi.git

Package: mknbi
Depends: ${misc:Depends}, perl
Architecture: any-amd64 any-i386
Description: Create tagged images for Etherboot or Netboot
 With mknbi you can create tagged images for Etherboot. Tagged images are data
 files, which contain the necessary files for booting up (kernel+root for
 Linux, kernel+minifs for DOS, ...) bundled together with a special format.
 .
 These tagged images are downloaded and understood by Etherboot and Netboot
 during the boot process.
 .
 This package should be used on the server and not on the client. It doesn't
 contain code which handles the network card, downloads the image, etc.

=== debian/rules ===
#!/usr/bin/make -f

export FIRSTRELOCS=0x82800 0x92800

%:
	dh ${@}

override_dh_auto_clean:
	rm -f nfl menu
	rm -f first32\@0x82800.linux
	rm -f first32\@0x82800.linux
	rm -f first32elf\@0x92800.linux
	rm -f first32elf\@0x92800.linux

	$(MAKE) clean

override_dh_auto_build:
	$(MAKE) PREFIX=/usr

override_dh_auto_install:
	mkdir -p debian/mknbi/usr/lib/mknbi

	cp mknbi debian/mknbi/usr/lib/mknbi/mknbi
	cp disnbi.pl debian/mknbi/usr/lib/mknbi/disnbi
	cp dismbr.pl debian/mknbi/usr/lib/mknbi/dismbr
	cp disdosbb.pl debian/mknbi/usr/lib/mknbi/disdosbb

	cp Nbi.pm Elf.pm TruncFD.pm \
	$(foreach i,$(FIRSTRELOCS),first32@$(i).linux first32elf@$(i).linux) \
	first.dos first.fdos menu debian/mknbi/usr/lib/mknbi

override_dh_installchangelogs:
	dh_installchangelogs LOG

override_dh_fixperms:
	dh_fixperms

	chmod 0644 debian/mknbi/usr/lib/mknbi/*.linux
	chmod 0644 debian/mknbi/usr/lib/mknbi/*.pm
	chmod 0644 debian/mknbi/usr/lib/mknbi/menu
